Codeforces 148 E Porcelain【dp】

E. Porcelain
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

During her tantrums the princess usually smashes some collectable porcelain. Every furious shriek is accompanied with one item smashed.

The collection of porcelain is arranged neatly on n shelves. Within each shelf the items are placed in one row, so that one can access only the outermost items — the leftmost or the rightmost item, not the ones in the middle of the shelf. Once an item is taken, the next item on that side of the shelf can be accessed (see example). Once an item is taken, it can't be returned to the shelves.

You are given the values of all items. Your task is to find the maximal damage the princess' tantrum of m shrieks can inflict on the collection of porcelain.

Input

The first line of input data contains two integers n (1 ≤ n ≤ 100) and m (1 ≤ m ≤ 10000). The next n lines contain the values of the items on the shelves: the first number gives the number of items on this shelf (an integer between 1 and 100, inclusive), followed by the values of the items (integers between 1 and 100, inclusive), in the order in which they appear on the shelf (the first number corresponds to the leftmost item, the last one — to the rightmost one). The total number of items is guaranteed to be at least m.

Output

Output the maximal total value of a tantrum of m shrieks.

Examples
input
2 3
3 3 7 2
3 4 1 5
output
15
input
1 3
4 4 3 1 2
output
9
Note

In the first case there are two shelves, each with three items. To maximize the total value of the items chosen, one can take two items from the left side of the first shelf and one item from the right side of the second shelf.

In the second case there is only one shelf, so all three items are taken from it — two from the left side and one from the right side.


题目大意:

给你n排书,问拿m本书的最大价值。每一次拿只能从任意排书的最左端或者是最右端拿。


思路:


1、贪心显然容易GG,考虑DP。


2、然后考虑一个这样的问题:虽然局部最优不能带来整体最优,但是局部最优可以通过动态规划的方式来达到整体最优,我们不妨设w【i】【j】表示第i行拿j本书的最大价值,也就是我刚才所谓的局部最优,如果我们有了这个值,那么再设定dp【i】【j】表示从第一行开始规划规划到了第i行一共拿j本书的最大价值。


3、那么状态转移方程:

dp【i】【j】=max(dp【i】【j】,dp【i-1】【j-jj】+w【i】【jj】);


4、那么问题在考虑回来,w【i】【j】要如何求?其实并不难,我们求每一行的前缀和,以及后缀和即可。具体处理细节,看下边代码即可


Ac代码:


#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
int dp[150][10050];
int qian[150][150];
int hou[150][150];
int w[150][150];
int a[150][150];
int k[150];
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        memset(w,0,sizeof(w));
        memset(dp,0,sizeof(dp));
        memset(qian,0,sizeof(qian));
        memset(hou,0,sizeof(hou));
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&k[i]);
            for(int j=1;j<=k[i];j++)
            {
                scanf("%d",&a[i][j]);
                qian[i][j]=qian[i][j-1]+a[i][j];
            }
        }
        for(int i=1;i<=n;i++)
        {
            int tmpp=1;
            for(int j=k[i];j>=1;j--)
            {
                hou[i][tmpp]=hou[i][tmpp-1]+a[i][j];
                tmpp++;
            }
        }
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=k[i];j++)
            {
                w[i][j]=max(qian[i][j],hou[i][j]);
                for(int l=1;l<=j;l++)
                {
                    w[i][j]=max(qian[i][l]+hou[i][j-l],w[i][j]);
                }
            }
        }
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<=m;j++)
            {
                for(int jj=0;jj<=j&&jj<=k[i];jj++)
                {
                    dp[i][j]=max(dp[i][j],dp[i-1][j-jj]+w[i][jj]);
                }
            }
        }
        printf("%d\n",dp[n][m]);
    }
}



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值